Scala Compiler2.12.2-20170504-135222-21d12e9 < Back
 

# Packages

-  package root

  The Scala compiler and reflection APIs.

  The Scala compiler and reflection APIs.

  Definition Classes
    root
-  package scala
  Definition Classes
    root
-  package tools
  Definition Classes
    scala
-  package nsc
  Definition Classes
    tools
-  package transform
  Definition Classes
    nsc
-  package patmat
  Definition Classes
    transform
- Debugging
- Interface
- Lit
- Logic
- MatchAnalysis
- MatchApproximation
- MatchCodeGen
- MatchCps
- MatchOptimization
- MatchTranslation
- MatchTreeMaking
- MatchWarnings
- PatternExpander
- PatternMatching
- PatternMatchingStats
- ScalaLogic
- ScalacPatternExpanders
- Solving
- TreeAndTypeAnalysis

t

scala.tools.nsc.transform.patmat

# Interface 

###

#### trait Interface extends TreeDSL

Source
  PatternMatching.scala

Linear Supertypes
TreeDSL, AnyRef, Any
Known Subclasses
patmat, MatchAnalysis, MatchApproximation, MatchCodeGen, MatchOptimization, MatchTreeMaking, PatternMatching, ScalaLogic
Type Hierarchy
 
Ordering

1. Alphabetic
2. By Inheritance

Inherited

1. Interface
2. TreeDSL
3. AnyRef
4. Any

Implicitly

1. by any2stringadd
2. by StringFormat
3. by Ensuring
4. by ArrowAssoc

1. Hide All
2. Show All

Visibility

1. Public
2. All

### Type Members

1.  trait MatchMonadInterface extends AnyRef

   Interface with user-defined match monad? if there's a `__match` in scope, we use this as the match strategy, assuming it conforms to MatchStrategy as defined below:

   Interface with user-defined match monad? if there's a `__match` in scope, we use this as the match strategy, assuming it conforms to MatchStrategy as defined below:

       type Matcher[P[_], M[+_], A] = {
         def flatMap[B](f: P[A] => M[B]): M[B]
         def orElse[B >: A](alternative: => M[B]): M[B]
       }

       abstract class MatchStrategy[P[_], M[+_]] {
         // runs the matcher on the given input
         def runOrElse[T, U](in: P[T])(matcher: P[T] => M[U]): P[U]

         def zero: M[Nothing]
         def one[T](x: P[T]): M[T]
         def guard[T](cond: P[Boolean], then: => P[T]): M[T]
       }

   P and M are derived from one's signature (`def one[T](x: P[T]): M[T]`)

   if no `__match` is found, we assume the following implementation (and generate optimized code accordingly)

       object __match extends MatchStrategy[({type Id[x] = x})#Id, Option] {
         def zero = None
         def one[T](x: T) = Some(x)
         // NOTE: guard's return type must be of the shape M[T], where M is the monad in which the pattern match should be interpreted
         def guard[T](cond: Boolean, then: => T): Option[T] = if(cond) Some(then) else None
         def runOrElse[T, U](x: T)(f: T => Option[U]): U = f(x) getOrElse (throw new MatchError(x))
       }

2.  trait TypedSubstitution extends MatchMonadInterface

### Abstract Value Members

1.  abstract val global: Global
   Definition Classes
     TreeDSL

### Concrete Value Members

1.  object CODE
   Definition Classes
     TreeDSL
2.  final def !=(arg0: Any): Boolean
   Definition Classes
     AnyRef → Any
3.  final def ##(): Int
   Definition Classes
     AnyRef → Any
4.  def +(other: String): String
   Implicit
     This member is added by an implicit conversion from Interface to any2stringadd[Interface] performed by method any2stringadd in scala.Predef.
   Definition Classes
     any2stringadd
5.  def ->[B](y: B): (Interface, B)
   Implicit
     This member is added by an implicit conversion from Interface to ArrowAssoc[Interface] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()
6.  final def ==(arg0: Any): Boolean
   Definition Classes
     AnyRef → Any
7.  final def asInstanceOf[T0]: T0
   Definition Classes
     Any
8.  def clone(): AnyRef
   Attributes
     protected[java.lang]
   Definition Classes
     AnyRef
   Annotations
     @throws( ... )
9.  final def dealiasWiden(tp: Global.Type): Global.Type
   Attributes
     protected
10.  def ensuring(cond: (Interface) ⇒ Boolean, msg: ⇒ Any): Interface
    Implicit
      This member is added by an implicit conversion from Interface to Ensuring[Interface] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
11.  def ensuring(cond: (Interface) ⇒ Boolean): Interface
    Implicit
      This member is added by an implicit conversion from Interface to Ensuring[Interface] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
12.  def ensuring(cond: Boolean, msg: ⇒ Any): Interface
    Implicit
      This member is added by an implicit conversion from Interface to Ensuring[Interface] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
13.  def ensuring(cond: Boolean): Interface
    Implicit
      This member is added by an implicit conversion from Interface to Ensuring[Interface] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
14.  final def eq(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef
15.  def equals(arg0: Any): Boolean
    Definition Classes
      AnyRef → Any
16.  def finalize(): Unit
    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( classOf[java.lang.Throwable] )
17.  def formatted(fmtstr: String): String
    Implicit
      This member is added by an implicit conversion from Interface to StringFormat[Interface] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()
18.  final def getClass(): Class[_]
    Definition Classes
      AnyRef → Any
19.  final def hasStableSymbol(p: Global.Tree): Boolean
    Attributes
      protected
20.  def hashCode(): Int
    Definition Classes
      AnyRef → Any
21.  final def isInstanceOf[T0]: Boolean
    Definition Classes
      Any
22.  final def mkFALSE: Global.Literal
    Attributes
      protected
23.  final def mkTRUE: Global.Literal
    Attributes
      protected
24.  final def ne(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef
25.  final def notify(): Unit
    Definition Classes
      AnyRef
26.  final def notifyAll(): Unit
    Definition Classes
      AnyRef
27.  final def synchronized[T0](arg0: ⇒ T0): T0
    Definition Classes
      AnyRef
28.  def toString(): String
    Definition Classes
      AnyRef → Any
29.  final def wait(): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )
30.  final def wait(arg0: Long, arg1: Int): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )
31.  final def wait(arg0: Long): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )
32.  def →[B](y: B): (Interface, B)
    Implicit
      This member is added by an implicit conversion from Interface to ArrowAssoc[Interface] performed by method ArrowAssoc in scala.Predef.
    Definition Classes
      ArrowAssoc
33.  object vpmName

### Inherited from TreeDSL

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd from Interface to any2stringadd[Interface]

### Inherited by implicit conversion StringFormat from Interface to StringFormat[Interface]

### Inherited by implicit conversion Ensuring from Interface to Ensuring[Interface]

### Inherited by implicit conversion ArrowAssoc from Interface to ArrowAssoc[Interface]

### Ungrouped